#ifndef _TCFS_FS_SB
#define _TCFS_FS_SB

#include <linux/tcrpcsock.h>
#include <linux/tcfs.h>

struct tcfs_server {
  struct file *file;
  struct tcrpc_sock *rsock;
  struct sockaddr toaddr ;  /* Added for change to TCFS code to use sendto()  1995-06-02  JSP */
  int lock;
  struct wait_queue *wait;
  int flags;
  int rsize;
  int wsize;
  int timeo;
  int retrans;
  int acregmin;
  int acregmax;
  int acdirmin;
  int acdirmax;
  struct tcfs_server * os;
  char hostname[256];
};

/*
 * tcfs super-block data in memory
 */

struct tcfs_sb_info {
  struct tcfs_server s_server;
  struct tcfs_server x_server;
  struct tcfs_fh s_root;
};

#endif
